#ifndef _MIXER_H
#define _MIXER_H

#include <linux/ioctl.h>

typedef struct {
	unsigned int l_gain, r_gain;
} ctrl_gain_t;
  
typedef struct {
	uint16_t stream1, stream2;
} stream_t;

typedef struct {
	ctrl_gain_t gain;
} ctrl_arg_t;

typedef struct {
	stream_t stream;
} stream_arg_t;

#define MIXER_CTRL_MAGIC 'r'
#define MIXER_STREAM_MAGIC 's'

/* ioctls and their arguments */
#define CTRL_WRITE_GAIN _IOW(MIXER_CTRL_MAGIC, 1, ctrl_gain_t *)
#define STREAM_WRITE_STREAM _IOW(MIXER_STREAM_MAGIC, 1, stream_t *)
#define STREAM_READ_STREAM _IOR(MIXER_STREAM_MAGIC, 2, stream_t *)

#endif
